module Ventiuna
	class Card
		attr_accessor :rank, :suit

		def initialize(rank: "joker", suit: "joker")
			@rank = rank.to_s.upcase
			@suit = suit
		end

		def to_i(high: true, low: false)
			return 1  if self.ace? && low
			return 11 if self.ace? && high
			return 10 if ["K", "Q", "J"].include?(self.rank)
			self.rank.to_i
		end
		alias :value :to_i

		def ace?
			self.rank == "A"
		end

		# sorts cards with Aces always high
		def <=>(other_card)
			self.value(high: true) <=> other_card.value(high: true)
		end

		def ==(other_card)
			self.to_s == other_card.to_s
		end

		def to_s
			"#{self.rank} #{self.suit}"
		end
	end
end