module Ventiuna
	class Deck
		@@suits = ["club", "spade", "heart", "diamond"]
		@@ranks = %w(2 3 4 5 6 7 8 9 10 J Q K A)

		attr_accessor :cards

		def initialize
			@cards = []
			@@suits.each do |suit|
				@@ranks.each do |rank|
					@cards << Ventiuna::Card.new(rank: rank, suit: suit)
				end
			end
			@shuffled = false
		end

		def shuffle
			@cards.shuffle!
			@shuffled = true
			self
		end

		def shuffled?
			@shuffled
		end

		def size
			self.cards.size
		end

		def pop
			@cards.pop
		end

		def ==(other_deck)
			self.cards == other_deck.cards
		end
	end
end